#ifndef _LogRecord_H
#define _LogRecord_H
// Cut code starting
#include <string>
enum LogRecordType
{
	LogData,
	LogString,
	LogInt,
	LogLong,
	LogNV,
};

enum Criticality
{
	CRITICAL,
	MAJOR,
	MINOR,
	INFO
};
// Cut code ending
class LogRecordImpl;
class LogRecord 
{
public:
	~LogRecord();
	 LogRecord( Criticality  crit, unsigned int  type, unsigned int  tag, unsigned int  comp, unsigned int  file, unsigned int  line);
	 LogRecord( char*  loadData, unsigned int  size);
	void insert( unsigned int  name, void*  data, unsigned int  size);
	void insert( const void*  data, unsigned int  size);
	void insert( const string&  s);
	void insert( LogRecordType  type);
	void insert( unsigned int  i);
	string getType();
	string getTag();
	string& getCriticality();
	string getComponent();
	string getFile();
	int getLine();
	int getPid();
	string getTime();
	unsigned int getSize();
	void print( ostream&  os);
	void store( char*  dest);
private:
	LogRecordImpl* m_impl;
};
#endif
