#ifndef _LOGSTOREIMPL_H
#define _LOGSTOREIMPL_H

#include <memory>
#include "LogStoreFactory.h"
#include "LogStore.h"

/* GENCODE START
#include "LogRecord.h"
#include <iostream.h>
class LogStoreException
{
public:
	LogStoreException( const string& msg ) : m_msg(msg)
	{
	}

	const string& getMsg() { return m_msg; }
private:
	string m_msg;
};
   GENCODE END */

class LogStoreImpl
{
public:
	LogStoreImpl(LogStore*) 
	{
	}
	virtual ~LogStoreImpl()
	{
	}

	static LogStore* GetInstance()
	{
		if( m_Instance.get() == NULL )
		{
			LogStoreFactory logStoreFactory;
			auto_ptr<LogStore> tmp(logStoreFactory.createLogStore());
			m_Instance = tmp;
		}
		return m_Instance.get();
	}

	virtual void store(LogRecord* record) = 0;
//	virtual void output( ostream& out, Filter* filter) = 0;
	virtual void outputAll(ostream& out) = 0;
	
protected:
	static auto_ptr<LogStore>	m_Instance;
};

#endif
