/* ****************************************************************************
 *
 *  ExtendedCommands.h
 *  Created by John F. Hubbard, on Sun Aug 26 2001, 13:42:19
 *
 *  Copyright (C) 2001, John F. Hubbard
 *
 *  Permission is granted to use this code without restriction,
 *  as long as this copyright notice appears in all source files.
 *
 *
 *  File Contents: Interface and documentation of the ExtendedCommands component.
 *
 *  $Revision: 1.4 $
 *  $Date: 2001/12/04 04:13:46 $
 *  $Author: jhubbard $
 *************************************************************************** */

#ifndef JFH_OUT_OF_BAND_EXAMPLE_EXTENDEDCOMMANDS_H
#define JFH_OUT_OF_BAND_EXAMPLE_EXTENDEDCOMMANDS_H

#include "CommandLine.h"

namespace out_of_band_example
{

/** Purpose: Extend the CommandLine class, so as to provide functions
	that are needed for creating a new command-line string.  This is useful
	when you are forking (spawning) a new process that has command-line
	arguments.
 */
class ExtendedCommands : public tools::CommandLine
{
public:
    /// Constructor.
    ExtendedCommands(int argc, char* argv[]);
    virtual ~ExtendedCommands();

	/** GetOption()
	*/
	bool GetOption(  const std::string& optionName,
					 const std::string& alternateName,
					 std::string& result,
					 const std::string&	defaultValue = ""  ) const;

	/** SynthesizeOptionString()
	*/
	std::string SynthesizeOptionString(  const std::string& optionName,
										 const std::string& alternateName,
										 const std::string&	defaultValue = "" ) const;
};

} // end of the out_of_band_example namespace

#endif // #ifndef JFH_OUT_OF_BAND_EXAMPLE_EXTENDEDCOMMANDS_H

