/* ****************************************************************************
 *
 *  SimpleCalculator.cpp
 *  Created by John F. Hubbard, on Sun Aug 26 2001, 16:36:55
 *
 *  Copyright (C) 2001, John F. Hubbard
 *
 *  Permission is granted to use this code without restriction,
 *  as long as this copyright notice appears in all source files.
 *
 *
 *  File Contents: The ChildProcess program.
 *
 *  $Revision: 1.2 $
 *  $Date: 2001/12/05 05:10:43 $
 *  $Author: jhubbard $
 *************************************************************************** */

#include <string>
#include <iostream>
#include "CommandLine.h"
#include "Calculator.tab.h"
#include "BisonWorkarounds.h"

std::string
GetVersion()
{	return "1.20-calculator";
}

int main(int argc, char* argv[])
{
	try
	{
		tools::CommandLine commands(argc, argv);
		
		if( commands.Exists("version") )
		{	
			std::cout << "Simple Calculator version: " <<
					  GetVersion() << std::endl;
			exit(0);
		}

		if( commands.Exists("yydebug") )
		{   yydebug = 1;
		}
		yyparse( reinterpret_cast<void*>( &commands ) );
	}
	catch( std::string& strCommandLineError )
	{
		std::cout << "Simple Calculator error: " <<
			 strCommandLineError << std::endl;
		exit(1);
	}
	return 0;
}

