#ifndef _CALLSTATECOMPLETEIMPL_H
#define _CALLSTATECOMPLETEIMPL_H

#include "CallStateImpl.h"
#include "SimpleCall.h"
#include "CallStateEnd.h"
#include "CallStateComplete.h"

/* GENCODE START
#include "CallState.h"
class SimpleCall;
 * GENCODE END */

class CallStateCompleteImpl : public CallStateImpl
{
public:
	CallStateCompleteImpl(SimpleCall* callobj, CallStateComplete*) : CallStateImpl(callobj)
	{
		m_name = "Complete";
	}

	void inputDisconnectCalled()
	{
		// WATCH@ m_callobj->getCallId()
		// Transition to the end call state
		// Note that normally we would start what
		// is known as time release disconnect to
		// allow the called party to pick up and
		// resume the call within a specified period of time.
		// We will not show that code here since we are a
		// simple call.
		m_callobj->changeState( new CallStateEnd(m_callobj) );
	}
	void inputDisconnectCalling()
	{
		// WATCH@ m_callobj->getCallId()
		// Transition to the end call state
		m_callobj->changeState( new CallStateEnd(m_callobj) );
	}
};


#endif
