#ifndef _CALLSTATEENDIMPL_H
#define _CALLSTATEENDIMPL_H

#include "CallStateImpl.h"
#include "SimpleCall.h"
#include "CallStateComplete.h"
#include "CallStateEnd.h"

/* GENCODE START
#include "CallState.h"
class SimpleCall;
 * GENCODE END */

class CallStateEndImpl : public CallStateImpl
{
public:
	CallStateEndImpl(SimpleCall* callobj, CallStateEnd*) : CallStateImpl(callobj)
	{
		m_name = "End";
	}

	void inputBillCall()
	{
		// WATCH@ m_callobj->getCallId()
		// Normally we would bill the call at this point
		// but all simple calls are free.
	}
	void inputAnswer()
	{
		// WATCH@ m_callobj->getCallId()
		// The called party went back off hook,
		// resume the call
		m_callobj->changeState( new CallStateComplete(m_callobj) );
	}
};


#endif
