#ifndef _SIMPLECALLIMPL_H
#define _SIMPLECALLIMPL_H

#include <string>
#include <strstream.h>
#include "LogRecordSpec.h"
#include "LogStore.h"
#include "CallImpl.h"
#include "SimpleCall.h"
#include "CallStateInitializing.h"

/* GENCODE START
#include <string>
#include "LogRecordSpec.h"
class InvalidStateException
{
public:
	InvalidStateException( const string& state ) : m_state(state)
	{
	}

	const string& getState() { return m_state; }
private:
	string m_state;
};

class CallState;
 * GENCODE END */

/*class CallStateStable : public CallState
{
};

class CallStateEnd : public CallState
{
};*/

unsigned int GetCallId()
{
	static unsigned int callid = 0;
	return ++callid;
}

class SimpleCallImpl : public CallImpl
{
public:
	SimpleCallImpl( const string& calledNumber, const string& callingNumber, SimpleCall* scall ) : CallImpl(GetCallId(), callingNumber, calledNumber)
	{
		auto_ptr<CallState> tmp = auto_ptr<CallState>(new CallStateInitializing(scall));
		m_state = tmp;
		// WATCH@ m_callid m_callingNumber m_calledNumber *(m_state.get())
	}
	
	unsigned int getCallId()
	{
		return m_callid;
	}

	// Define state machine methods
	void changeState( CallState* newState )
	{
		auto_ptr<CallState> tmp = auto_ptr<CallState>(newState);
		m_state = tmp;
	}
	
	// Start a call
	void inputMakeCall()
	{
		m_state->inputMakeCall();
	}
	// Routing to called party completed
	void inputRouteComplete()
	{
		m_state->inputRouteComplete();
	}
	// Called party answered
	void inputAnswer()
	{
		m_state->inputAnswer();
	}
	// Called party hung up
	void inputDisconnectCalled()
	{
		m_state->inputDisconnectCalled();
	}
	// Calling party hung up
	void inputDisconnectCalling()
	{
		m_state->inputDisconnectCalling();
	}
	void inputBillCall()
	{
		m_state->inputBillCall();
	}
};

#endif





