#!/usr/bin/env ruby

require 'classdesc'
require 'logstring'

if ARGV[1] == '-i' then $abstractFlag = true; ARGV.pop
else $abstractFlag = false end

$baseClassName = ARGV[0].chomp("Impl.h")
$interfaces = Interfaces.new($baseClassName)
$interfaceName = $baseClassName
$inclass = false
$inpublic = false
$ingencode = false
$extGenCode = []

while gets
	case $_
	when /class\s+#{$interfaces.className}Impl/
		$interfaces.addClass(ClassDesc.new($baseClassName,$interfaceName))
		$interfaces.lastClass.addInheritance($_) if $_ =~ /public\s+\w[\w\d_]+Impl/
		$inclass = true

	when /^};/
		$inclass = false
		$inpublic=false

	when /public\s*:/
		$inpublic = true if $inclass 

	when /^\s*#{$interfaces.className}Impl\s*\(.*?\)/
		$interfaces.addClass(ClassDesc.new($baseClassName,$interfaceName)) if ($interfaces.lastClass.nil? || $interfaces.lastClass.name != $interfaceName)
		$interfaces.lastClass.addConstructor($_.sub('Impl','').sub(/[,]*\s*#{$baseClassName}\s*\*\s*[\w\d_]*\s*\)/,')'), "#{$interfaces.className}Impl") if $inpublic && !$abstractFlag

	when /(protected|private)\s*:/
		$inpublic = false

	when /^\s(virtual\s+|inline\s+|const\s+|static\s+){0,1}(unsigned\s+|const\s+|virtual\s+|inline\s+|static\s+){0,1}(\w[\w\d_]+\s*::\s*){0,1}\w[<>\w\d_&\*]*\s+\w[\w\d_]+\s*\(/
		$interfaces.addClass(ClassDesc.new($baseClassName,$interfaceName)) if ($interfaces.lastClass.nil? || $interfaces.lastClass.name != $interfaceName)
		$interfaces.lastClass.addMethod($_) if $inpublic

	when /\/\*\s*GENCODE START/
		$_ = "// Cut code starting"
		$ingencode = true

	when /GENCODE END/
		if $inclass then $interfaces.lastClass.addInClassCode("// Cut code ending") else $extGenCode << "// Cut code ending" end
		$ingencode = false

	when /\/\/\s*interface\s+([\w\d]+)/
		$interfaceName = "#{$interfaces.className}#{$1}"

	end
	if $ingencode 
		if $inclass 
			$interfaces.lastClass.addInClassCode($_) 
		else 
			$extGenCode << $_ 
		end 
	end
end

$interfaces.addExtClassCode($extGenCode)
$interfaces.createFiles $abstractFlag

