/***************************************************************************
                          helloworld.cpp  -  description
                             -------------------
    begin                : Thu Nov 15 22:12:20 EST 2001
    copyright            : (C) 2001 by Jason Mott
    email                : jmott@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "helloworld.h"
#include <qstring.h>

HelloWorld::HelloWorld(QWidget *parent, const char *name) : QWidget(parent, name)
{
    myCount = 0;
    countButton = new QPushButton("Count Button", this);
    countButton->setGeometry(100,100,100,40);
    countButton->show();

    countLabel = new QLabel(QString::number(myCount),this,"countlabel");
    countLabel->setGeometry(100,150,200,40);
    countLabel->show();

    resetButton = new QPushButton("Reset Button", this);
    resetButton->setGeometry(100,200,100,40);
    resetButton->show();

    connect(countButton, SIGNAL(clicked()), this, SLOT(intCount()));
    connect(this, SIGNAL(maxCountReached()), this, SLOT(disableCountButton()));
    connect(resetButton, SIGNAL(clicked()), this, SLOT(resetCount()));
}

HelloWorld::~HelloWorld()
{
}

void HelloWorld::intCount()
{
    if (++myCount >= MAX_COUNT) {
        myCount = MAX_COUNT;
        emit maxCountReached();
        QString labelText("Max count reached! ");
        labelText += QString::number(myCount);
        countLabel->setText(labelText);
    } else {
        countLabel->setText(QString::number(myCount));
    }
}

void HelloWorld::disableCountButton()
{
    countButton->setDisabled(true);
}

void HelloWorld::resetCount()
{
     myCount = 0;
     countButton->setEnabled(true);
     countLabel->setText(QString::number(myCount));
}

