#!/usr/bin/env ruby

$classAndVars = []
$hdrFiles = []

class LogSpec
	attr_reader :hdrFiles, :classAndVars
	
	@@instance = nil
	
	private_class_method :new
	
	def LogSpec.create
		@@instance = new unless @@instance
		@@instance
	end
	
	def initialize
		@hdrFiles, @classAndVars, @blob = [], [], nil
	end
	
	def parseSpec
		File.open("logclass.spec", "r") { |file|
			while file.gets 
				case $_
				when /\s*#/
				when /(\w[\w\d_]+)\s+(\w[\w\d_]+\.h)\s+(.*)/
					@hdrFiles << $2
					@classAndVars << [$1, $3]
				end
			end
		}
	end
	
	def find( findStr )
		@blob = File.open("logclass.spec", "r") { |file| file.read } unless @blob
		@blob.find { |line| line[/(#{findStr}[\w\d_]*)/]; findStr == $1 }
	end
end

